## pacutils-0.14.0-2.src.tar.zst

=== Makefile ===
all: lib src

lib:
	$(MAKE) -C $@ all

src: lib
	$(MAKE) -C $@ all

check: lib src
	$(MAKE) -C t/ check

doc:
	$(MAKE) -C doc/ $@

tidy:
	astyle --options=.astylerc --exclude=ext --recursive "*.c,*.h" --suffix=none

install: lib
	$(MAKE) -C doc/ $@
	$(MAKE) -C lib/ $@
	$(MAKE) -C src/ $@

clean:
	$(MAKE) -C doc/ $@
	$(MAKE) -C lib/ $@
	$(MAKE) -C src/ $@
	$(MAKE) -C t/ $@

.PHONY: all check clean doc install lib src tidy

=== doc/Makefile ===
-include ../configure.mk
-include configure.mk

PREFIX      ?= /usr/local
DATAROOTDIR ?= $(PREFIX)/share
MANDIR      ?= $(DATAROOTDIR)/man
MAN1DIR     ?= $(MANDIR)/man1
MAN1EXT     ?= .1
MAN3DIR     ?= $(MANDIR)/man3
MAN3EXT     ?= .3
MAN7DIR     ?= $(MANDIR)/man7
MAN7EXT     ?= .7

MAN1PAGES = \
						paccapability$(MAN1EXT) \
						paccheck$(MAN1EXT) \
						pacconf$(MAN1EXT) \
						pacfile$(MAN1EXT) \
						pacinfo$(MAN1EXT) \
						pacini$(MAN1EXT) \
						paclock$(MAN1EXT) \
						paclog$(MAN1EXT) \
						pacrepairdb$(MAN1EXT) \
						pacrepairfile$(MAN1EXT) \
						pacreport$(MAN1EXT) \
						pacsift$(MAN1EXT) \
						pacsync$(MAN1EXT) \
						pactrans$(MAN1EXT)

MAN3PAGES = \
						pacutils-mtree$(MAN3EXT)

MAN7PAGES = \
						pacutils-sysroot$(MAN7EXT)

all: doc

%$(MAN1EXT): %.pod
	pod2man --center $* --release pacutils --section 1  $< $@

%$(MAN3EXT): %.pod
	pod2man --center $* --release pacutils --section 3  $< $@

%$(MAN7EXT): %.pod
	pod2man --center $* --release pacutils --section 7  $< $@

pacinstall$(MAN1EXT): | pactrans$(MAN1EXT)
	ln -fs $| $@

pacremove$(MAN1EXT): | pactrans$(MAN1EXT)
	ln -fs $| $@

doc: $(MAN1PAGES) $(MAN3PAGES) $(MAN7PAGES) pacinstall$(MAN1EXT) pacremove$(MAN1EXT)

install: doc
	install -d "${DESTDIR}${MAN1DIR}"
	install -d "${DESTDIR}${MAN3DIR}"
	install -d "${DESTDIR}${MAN7DIR}"
	install -m 644 $(MAN1PAGES) "${DESTDIR}${MAN1DIR}"
	install -m 644 $(MAN3PAGES) "${DESTDIR}${MAN3DIR}"
	install -m 644 $(MAN7PAGES) "${DESTDIR}${MAN7DIR}"
	cp -d pacinstall$(MAN1EXT) "${DESTDIR}${MAN1DIR}"
	cp -d pacremove$(MAN1EXT)  "${DESTDIR}${MAN1DIR}"

clean:
	$(RM) $(MAN1PAGES) $(MAN3PAGES) $(MAN7PAGES) pacinstall$(MAN1EXT) pacremove$(MAN1EXT)

.PHONY: all clean doc install

=== lib/Makefile ===
-include ../configure.mk
-include configure.mk

ALPM_CFLAGS ?= $(shell pkg-config libalpm --cflags)

CFLAGS ?= -Wall -Wextra -Wpedantic -Werror -g

override CFLAGS += $(ALPM_CFLAGS)
override LDLIBS += -lalpm

PREFIX        ?= /usr/local
EXEC_PREFIX   ?= ${PREFIX}
BINDIR        ?= ${EXEC_PREFIX}/bin
INCLUDEDIR    ?= ${PREFIX}/include
LIBDIR        ?= ${EXEC_PREFIX}/lib
LOCALSTATEDIR ?= ${PREFIX}/var
SYSCONFDIR    ?= ${PREFIX}/etc

CACHEDIR   ?= ${LOCALSTATEDIR}/cache/pacman/pkg
DBEXT      ?= .db
DBPATH     ?= ${LOCALSTATEDIR}/lib/pacman
GPGDIR     ?= ${SYSCONFDIR}/pacman.d/gnupg
HOOKDIR    ?= ${SYSCONFDIR}/pacman.d/hooks
LOGFILE    ?= ${LOCALSTATEDIR}/log/pacman.log
ROOTDIR    ?= /

override CPPFLAGS += \
	-DCACHEDIR=\"$(CACHEDIR)\" \
	-DDBEXT=\"$(DBEXT)\" \
	-DDBPATH=\"$(DBPATH)\" \
	-DGPGDIR=\"$(GPGDIR)\" \
	-DHOOKDIR=\"$(HOOKDIR)\" \
	-DLOCALSTATEDIR=\"$(LOCALSTATEDIR)\" \
	-DLOGFILE=\"$(LOGFILE)\" \
	-DROOTDIR=\"$(ROOTDIR)\" \
	-DSYSCONFDIR=\"$(SYSCONFDIR)\"

GITTAG = $(shell git describe --abbrev=0 2>/dev/null)
ifneq ($(GITTAG),)
	GITVER = $(subst $(GITTAG)-,,$(shell git describe --dirty))
	ifneq ($(GITTAG),$(GITVER))
		override CPPFLAGS += -DGITVER=\"$(GITVER)\"
	endif
endif

HEADERS = \
					pacutils.h \
					pacutils/config.h \
					pacutils/depends.h \
					pacutils/log.h \
					pacutils/mtree.h \
					pacutils/ui.h \
					pacutils/util.h

SOURCES = \
					../ext/globdir.c/globdir.c \
					../ext/mini.c/mini.c \
					pacutils.c \
					pacutils/config.c \
					pacutils/depends.c \
					pacutils/log.c \
					pacutils/mtree.c \
					pacutils/ui.c \
					pacutils/util.c

all: libpacutils.so

libpacutils.so: ${SOURCES}
	$(CC) $(CPPFLAGS) -shared -fPIC $(CFLAGS) -o $@ $^ $(LDLIBS) $(LDFLAGS)

install: libpacutils.so
	install -d "${DESTDIR}${INCLUDEDIR}/pacutils"
	for h in ${HEADERS}; do install -m 644 $$h "${DESTDIR}${INCLUDEDIR}/$$h"; done
	install -d "${DESTDIR}${LIBDIR}"
	install -m 644 libpacutils.so "${DESTDIR}${LIBDIR}/libpacutils.so"

clean:
	$(RM) *.o *.so*

.PHONY: all clean install

=== t/Makefile ===
CFLAGS += -Wall -g -Wextra -I../lib
LDFLAGS += -L../lib
LDLIBS += -lpacutils -lalpm -larchive

ALPM_CFLAGS ?= $(shell pkg-config libalpm --cflags)
override CFLAGS += $(ALPM_CFLAGS)

PROVE ?= prove

GIT ?= git

TESTS += \
		 10-basename.t \
		 10-config-basic.t \
		 10-filelist_contains_path.t \
		 10-log-action-parse.t \
		 10-log-transaction-parse.t \
		 10-log-reader-basic.t \
		 10-mtree-basic.t \
		 10-parse-datetime.t \
		 10-pathcmp.t \
		 10-strreplace.t \
		 20-config-includes.t \
		 20-config-root-inheritance.t \
		 30-config-sysroot.t \
		 40-ui-cb-download-progress.t \
		 99-pu_list_shift.t

%.t: %.c ../lib/libpacutils.so ../ext/tap.c/tap.c Makefile
	$(CC) $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) $< $(LDLIBS) -o $@

check: tests
	LD_LIBRARY_PATH=../lib $(PROVE) $(TESTS)

tests: $(TESTS)

all: tests

valgrind: tests
	LD_LIBRARY_PATH=../lib $(PROVE) --exec="./runtest.sh -v" $(TESTS)

gcov: CC = gcc
gcov: CFLAGS += -fprofile-arcs -ftest-coverage
gcov: check
	gcov $(TESTS)

clean:
	$(RM) $(TESTS)
	$(RM) *.gcda *.gcno *.gcov

.PHONY: all clean check tests

=== ext/globdir.c/Makefile ===
check:                         ## build and run test suite
	$(MAKE) -C t/ check

clean:                         ## clean all built artifacts
	$(MAKE) -C t/ $@

update-ext:                    ## pull and commit updates to external modules
	git subtree pull --squash --prefix=ext/tap.c https://github.com/andrewgregory/tap.c.git master

help:                          ## show this help
	@grep -E '^[a-zA-Z_-]+:.*?## .*$$' $(MAKEFILE_LIST) | sort | awk 'BEGIN {FS = ":.*?## "}; {printf "\033[36m%-30s\033[0m %s\n", $$1, $$2}'

.PHONY: check clean update-ext help

=== ext/globdir.c/t/Makefile ===
PROVE ?= prove

GIT ?= git

CFLAGS += -Wall -Wextra -Wpedantic -g

override CPPFLAGS += -I..

TESTS = \
		01-sanity.t \
		10-escape_pattern.t \
		10-is_pattern.t \
		10-split_pattern.t \
		20-globat.t \
		30-globdir.t \
		40-glob_append.t \
		40-glob_dooffs.t \
		40-glob_err.t \
		40-glob_mark.t \
		40-glob_nocheck.t \
		40-glob_noescape.t \
		40-glob_nosort.t

01-sanity.t: CFLAGS += -pedantic -Werror

%.t: %.c ../globdir.c ../globdir.h globdir_test.h ../ext/tap.c/tap.c Makefile
	$(CC) $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) $< $(LDLIBS) -o $@

check: tests
	$(PROVE) --exec="./runtest.sh" $(TESTS)

valgrind: tests
	$(PROVE) --exec="./runtest.sh -v" $(TESTS)

Weverything: CC = clang
Weverything: CFLAGS += -Weverything -Wno-padded
Weverything: check

gcov: CC = gcc
gcov: CFLAGS += -fprofile-arcs -ftest-coverage
gcov: check
	gcov $(TESTS)

gprof: CC = gcc
gprof: CFLAGS += -pg
gprof: check

tests: $(TESTS)

all: tests

clean:
	$(RM) $(TESTS)
	$(RM) *.gcov *.gcda *.gcno gmon.out

.PHONY: all clean check gcov gprof tests Weverything

=== ext/mini.c/t/Makefile ===
# the tap.c submodule must be checked out to build and run tests

CFLAGS += -Wall -Wextra -Wpedantic -g

override CPPFLAGS += -I..

TESTS = 01-sanity.t 10-basic.t 10-lookup.t 90-smoke.t

01-sanity.t: CFLAGS += -std=c99 -pedantic -Werror

%.t: %.c ../mini.c ../mini.h tap.c/tap.c
	$(CC) $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) $< $(LDLIBS) -o $@

check: tests
	prove .

Weverything: CC = clang
Weverything: CFLAGS += -Weverything -Wno-padded
Weverything: check

gcov: CC = gcc
gcov: CFLAGS += -fprofile-arcs -ftest-coverage
gcov: check
	gcov $(TESTS)

gprof: CC = gcc
gprof: CFLAGS += -pg
gprof: check

tests: $(TESTS)

all: tests

clean:
	$(RM) $(TESTS)
	$(RM) *.gcov *.gcda *.gcno gmon.out

.PHONY: all clean check gcov gprof tests Weverything

=== PKGBUILD ===
# Maintainer: Jeremy Drake <github@jdrake.com>

pkgname=(pacutils pacutils-devel)
pkgver=0.14.0
pkgrel=2
pkgdesc="Utility library for libalpm front-ends (MSYS2 port)"
arch=('i686' 'x86_64')
url="https://github.com/andrewgregory/pacutils"
license=('MIT')
depends=('gcc-libs'
         'libarchive'
         'libcurl'
         'libgpgme'
         'libiconv'
         'libopenssl'
         'pacman')
makedepends=('libarchive-devel'
             'libcurl-devel'
             'libgpgme-devel'
             'perl'
             'make'
             'pkgconf'
             'gcc')
source=("${pkgname}-${pkgver}.tar.gz::https://github.com/andrewgregory/${pkgname}/archive/refs/tags/v${pkgver}.tar.gz"
        "0003-msysize.patch")
sha256sums=('b5d9be8472afea7ae43a0f15492eb3dce4bf768e0d2bb35284b5e1425ecd3849'
            'ad5f1aceee99a56f6ff39aaa03fabf99df7d5f6cdca60d842054f07754c44ab5')

prepare() {
  cd "${srcdir}/${pkgname}-${pkgver}"

  patch -Np1 -i "${srcdir}/0003-msysize.patch"
}

build() {
  cd "${srcdir}/${pkgname}-${pkgver}"

  make all doc PREFIX=/usr LOCALSTATEDIR=/var SYSCONFDIR=/etc SOPREFIX=msys- SOEXT=dll
  make -j1 DESTDIR="${srcdir}/prefix-${CARCH}" install PREFIX=/usr LOCALSTATEDIR=/var SYSCONFDIR=/etc SOPREFIX=msys- SOEXT=dll
}

check() {
  cd "${srcdir}/${pkgname}-${pkgver}"

  make check PREFIX=/usr LOCALSTATEDIR=/var SYSCONFDIR=/etc SOPREFIX=msys- SOEXT=dll
}

package_pacutils() {
  cd "${srcdir}"

  cp -fR "${srcdir}/prefix-${CARCH}/"* "${pkgdir}"
  rm -rf "${pkgdir}/usr/"{include,lib,share/man/man3}
}

package_pacutils-devel() {
  cd "${srcdir}"

  mkdir -p "${pkgdir}/usr/share/man"
  cp -fR "${srcdir}/prefix-${CARCH}/usr/"{include,lib} "${pkgdir}/usr/"
  cp -fR "${srcdir}/prefix-${CARCH}/usr/share/man/man3" "${pkgdir}/usr/share/man/"
}
